| Face Engine SDK 5.33.0 A face detection, recognition and tracking engine.

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Public Member Functions | List of all members
fsdk::IQualityEstimator Struct Referenceabstract
Estimators

Image quality estimator interface. More...

`#include <IQualityEstimator.h>`

Inheritance diagram for fsdk::IQualityEstimator:

## Public Member Functions
virtual Result< FSDKError > | estimate (const Image &warp, Quality &quality) const noexcept=0
| Estimate the quality. More...
virtual Result< FSDKError > | estimate (Span< const Image > warps, Span< Quality > quality) const noexcept=0
| Estimate the quality of multiple warped images in a single estimate function call. More...
virtual Result< FSDKError > | estimate (const Image &warp, SubjectiveQuality &quality) const noexcept=0
| Estimate the quality. More...
virtual Result< FSDKError > | estimate (Span< const Image > warps, Span< SubjectiveQuality > quality) const noexcept=0
| Estimate the subjective quality of multiple warped images in a single estimate function call. More...
virtual Result< FSDKError > | validate (Span< const Image > warps, Span< Result< FSDKError >> errors) const noexcept=0
| Validate input of multiple frames in a single function call. More...
Public Member Functions inherited from fsdk::IRefCounted
virtual int32_t | retain () noexcept=0
| Increase strong reference count. More...
virtual int32_t | retainLocked () noexcept=0
| Increase strong reference count thread safely. More...
virtual int32_t | release () noexcept=0
| Decrease strong reference count. More...
virtual int32_t | getRefCount () const noexcept=0
| Get actual strong reference count. More...
virtual int32_t | retainWeak () noexcept=0
| Increase weak reference count. More...
virtual int32_t | releaseWeak () noexcept=0
| Decrease weak reference count. More...
virtual int32_t | getWeakRefCount () const noexcept=0
| Get actual weak reference count. More...

## Detailed Description

Image quality estimator interface.

Note
  This estimator is designed to work with a person face image; you should pass a warped face detection image.

See Also
  IWarper for details. Quality estimator detects the same attributes as all the other estimators:
  - over/under exposure;
  - blurriness;
  - natural/unnatural colors; It is different in the sense that it computes all the estimations at once and returns the results merged somehow into a single value instead of several separate values. This way one can obtain a single scalar quality metric of a person face image. The estimated value is a probability that the image is good for both recognition and viewing purposes.

## Member Function Documentation

virtual Result<FSDKError> fsdk::IQualityEstimator::estimate | ( | const Image & | warp,
|  | Quality & | quality
| ) |  | const
| pure virtual noexcept

Estimate the quality.

Parameters

  [in] | warp | image with warped face.
  [out] | quality | output structure with quality params. Complex quality estimation available by method getQuality.

Returns
  Result with error code.

See Also
  Quality, Image, Result and FSDKError for details.

Note
  warp format must be R8G8B8,

See Also
  Format.

virtual Result<FSDKError> fsdk::IQualityEstimator::estimate | ( | Span< const Image > | warps,
|  | Span< Quality > | quality
| ) |  | const
| pure virtual noexcept

Estimate the quality of multiple warped images in a single estimate function call.

Parameters

  [in] | warps | span of images with warped faces.
  [out] | quality | output quality span.

Returns
  Result with error code.

See Also
  Span, Quality, Image, Result and FSDKError for details.

Note
  warps format must be R8G8B8,

See Also
  Format.

Note
  all spans should be based on user owned continuous collections.
  all spans should be equal size.

virtual Result<FSDKError> fsdk::IQualityEstimator::estimate | ( | const Image & | warp,
|  | SubjectiveQuality & | quality
| ) |  | const
| pure virtual noexcept

Estimate the quality.

Parameters

  [in] | warp | image with warped face.
  [out] | quality | output structure with subjective quality params.

Returns
  Result with error code.

See Also
  SubjectiveQuality, Image, Result and FSDKError for details.

Note
  warp format must be R8G8B8,

See Also
  Format.

virtual Result<FSDKError> fsdk::IQualityEstimator::estimate | ( | Span< const Image > | warps,
|  | Span< SubjectiveQuality > | quality
| ) |  | const
| pure virtual noexcept

Estimate the subjective quality of multiple warped images in a single estimate function call.

Parameters

  [in] | warps | span of images with warped faces.
  [out] | quality | output SubjectiveQuality span.

Returns
  Result with error code.

See Also
  Span, SubjectiveQuality, Image, Result and FSDKError for details.

Note
  warps format must be R8G8B8,

See Also
  Format.

Note
  all spans should be based on user owned continuous collections.
  all spans should be equal size.

virtual Result<FSDKError> fsdk::IQualityEstimator::validate | ( | Span< const Image > | warps,
|  | Span< Result< FSDKError >> | errors
| ) |  | const
| pure virtual noexcept

Validate input of multiple frames in a single function call.

Parameters

  [in] | warps | span of images with warped faces.
  [out] | errors | output span of errors for each image.

Returns
  Result with error code.

See Also
  Span, Image, Result and FSDKError for details.

Note
  warps format must be R8G8B8,

See Also
  Format.

Note
  all spans should be based on user owned continuous collections.
  all spans should be equal size.

The documentation for this struct was generated from the following file:

- include/fsdk/Estimators/IQualityEstimator.h